#include "include/timer.h" // 定义了获取 ticks 的函数
#include "include/types.h"
#include "xv6-user/user.h"
#include "include/syscall.h"
#include "include/riscv.h"
#include "include/vm.h"
extern uint64 sys_uptime(void);

// int gettimeofday(struct timeval *tv, struct timezone *tz)

// int gettimeofday(struct timeval *tv)
uint64 sys_gettimeofday(void) {
    uint64 addr;

    if (argaddr(0, &addr) < 0) {
        return -1;
    }

    uint64 time_counter = r_time();
    struct timeval ts;
    ts.tv_sec = time_counter / 1000000000;  //秒数
    ts.tv_usec = time_counter % 1000000000;  //毫秒数

    if (copyout2(addr, (char *)&ts, sizeof(ts)) < 0) {
        return -1;
    }
    return 0;
}
long get_uptime()
{
	return sys_uptime();
}
