#include "kernel/include/types.h"
#include "kernel/include/stat.h"
#include "kernel/include/fcntl.h"
#include "kernel/include/time.h" //gettimeofday自定义结构
#include "kernel/include/uname.h" //utsname结构
// #include "kernel/include/proc.h" //proc tms 结构

struct stat;
struct rtcdate;
struct sysinfo;
struct tms { 
  uint64 tms_utime;  //用户态执行时间  
  uint64 tms_stime;  //内核态执行时间
  uint64 tms_cutime; //子进程用户态执行时间
  uint64 tms_cstime; //子进程内核态执行时间
};

// system calls
int fork(void);
int exit(int) __attribute__((noreturn));
int wait(int*);
int pipe(int*);
int write(int fd, const void *buf, int len);
int read(int fd, void *buf, int len);
int close(int fd);
int kill(int pid);
int exec(char*, char**);
int open(const char *filename, int mode);
int fstat(int fd, struct stat*);
int mkdir(const char *dirname);
int chdir(const char *dirname);
int dup(int fd);
int getpid(void);
int getppid(void);
int waitpid(void);
char* sbrk(int size);
int sleep(int ticks);
int uptime(void);
int test_proc(int);
int dev(int, short, short);
int readdir(int fd, struct stat*);
int getcwd(char *buf);
int remove(char *filename);
int trace(int mask);
int sysinfo(struct sysinfo *);
int rename(char *old, char *new);
int shutdown(void); // call sbi_shutdown
// int wait4(int pid, int* status, int options);    // wait for
int gettimeofday(struct timeval *tv); //不考虑时区信息    
// int gettimeofday(struct timeval *tv, struct timezone *tz);    
int uname(struct utsname *osinfo);    
int times(struct tms *proctimes);    
uint64 brk(uint64 address);    

// ulib.c
int stat(const char*, struct stat*);
char* strcpy(char*, const char*);
char* strcat(char*, const char*);
void *memmove(void*, const void*, int);
char* strchr(const char*, char c);
int strcmp(const char*, const char*);
void fprintf(int, const char*, ...);
void printf(const char*, ...);
char* gets(char*, int max);
uint strlen(const char*);
void* memset(void*, int, uint);
void* malloc(uint);
void free(void*);
int atoi(const char*);
int memcmp(const void *, const void *, uint);
void *memcpy(void *, const void *, uint);
